-- This query calculates the new unique uids that yesterday put one ad in each language at least 
-- To get this number we are expanding the query new_uid_post_ad.sql over which we get the uids with more 
-- than one ad in each languages, and we simply count them. 
--

SELECT  
	count(*) AS stat_value,
	'<%%stat_name%>' <%(?lang) || '_%lang' %> AS stat_name
FROM 

(SELECT 
	users.uid
FROM 
	users JOIN ads USING (user_id)
WHERE
	status NOT IN ('inactive','refused') AND
uid IN

--- new_uids_post_ad.sql begin

(SELECT  
	uid 
FROM 
        users 
        JOIN user_params
              ON users.user_id = user_params.user_id AND 
		name = 'first_approved_ad'
WHERE uid IN (

	SELECT 
		distinct uid 
	FROM 
		users 
	WHERE  
		user_id IN (
			SELECT  
				 ads.user_id
			FROM
				ad_actions 
				JOIN action_states  AS verified ON 
					ad_actions.ad_id = verified.ad_id AND 
					ad_actions.action_id = verified.action_id AND 
					action_type IN ('new', 'editrefused') AND 
					verified.state = 'pending_review' AND 
					transition IN ('verify','pay', 'cleared_by') AND 
					timestamp >= '<%%stat_time%>' AND timestamp < TIMESTAMP '<%%stat_time%>' + INTERVAL '1 DAY'
				JOIN action_states AS approved ON 
					verified.ad_id=approved.ad_id AND 
					verified.action_id=approved.action_id AND 
					action_type IN ('new', 'editrefused') AND 
					approved.state = 'accepted' AND 
					approved.transition IN ('accept', 'accept_w_chngs') AND 
					approved.timestamp >= '<%%stat_time%>'
				JOIN ads ON 
					ads.ad_id=ad_actions.ad_id
				JOIN user_params ON 
					ads.user_id = user_params.user_id AND
					user_params.name = 'first_approved_ad' AND 
					approved.timestamp = user_params.value::timestamp
			UNION 

			SELECT
				 ads.user_id
			FROM 
				ad_actions 
				JOIN action_states  AS verified ON 
					ad_actions.ad_id = verified.ad_id AND 
					ad_actions.action_id = verified.action_id AND 
					action_type IN ('new', 'editrefused') AND 
					verified.state = 'pending_review' AND 
					transition IN ('verify','pay', 'cleared_by') AND 
					timestamp < '<%%stat_time%>'
				JOIN action_states AS approved ON 
					verified.ad_id=approved.ad_id AND 
					verified.action_id=approved.action_id AND 
					approved.state = 'accepted' AND 
					action_type IN ('new', 'editrefused') AND 
					approved.transition IN ('accept', 'accept_w_chngs') AND 
					approved.timestamp >= '<%%stat_time%>'
				JOIN ads ON 
					ads.ad_id=ad_actions.ad_id
				JOIN user_params ON 
					ads.user_id = user_params.user_id AND
					 user_params.name = 'first_approved_ad' AND 
					approved.timestamp = user_params.value::timestamp
		)
)
GROUP BY 1
HAVING 
	SUM(CASE  WHEN value::timestamp < '<%%stat_time%>' THEN 1 ELSE 0 END) = 0 ) 

--- new_uids_post_ad.sql end

GROUP BY uid
HAVING COUNT(distinct lang) > 1
) as foo;
